Index: /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID
===================================================================
--- /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID	(revision 1586)
+++ /ccr/trunk/kids/CCD-CCR_GENERATION_UTILITIES_1P2.KID	(revision 1587)
@@ -104056,927 +104086,921 @@
  ;   rcr@rcresearch.us
 "RTN","C0CMAIL2",6,0)
- ;  Licensed under the terms of the GNU
+ ;
 "RTN","C0CMAIL2",7,0)
- ;General Public License See attached copy of the License.
+ ; This program is free software: you can redistribute it and/or modify
 "RTN","C0CMAIL2",8,0)
- ;
+ ; it under the terms of the GNU Affero General Public License as
 "RTN","C0CMAIL2",9,0)
- ;This program is free software; you can redistribute it and/or modify
+ ; published by the Free Software Foundation, either version 3 of the
 "RTN","C0CMAIL2",10,0)
- ;it under the terms of the GNU General Public License as published by
+ ; License, or (at your option) any later version.
 "RTN","C0CMAIL2",11,0)
- ;the Free Software Foundation; either version 2 of the License, or
+ ;
 "RTN","C0CMAIL2",12,0)
- ;(at your option) any later version.
+ ; This program is distributed in the hope that it will be useful,
 "RTN","C0CMAIL2",13,0)
- ;
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 "RTN","C0CMAIL2",14,0)
- ;This program is distributed in the hope that it will be useful,
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 "RTN","C0CMAIL2",15,0)
- ;but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; GNU Affero General Public License for more details.
 "RTN","C0CMAIL2",16,0)
- ;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ;
 "RTN","C0CMAIL2",17,0)
- ;GNU General Public License for more details.
+ ; You should have received a copy of the GNU Affero General Public License
 "RTN","C0CMAIL2",18,0)
- ;
+ ; along with this program.  If not, see <http://www.gnu.org/licenses/>.
 "RTN","C0CMAIL2",19,0)
- ;You should have received a copy of the GNU General Public License along
+ ;
 "RTN","C0CMAIL2",20,0)
- ;with this program; if not, write to the Free Software Foundation, Inc.,
+ ;  ------------------
 "RTN","C0CMAIL2",21,0)
- ;51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ ;Entry Points
 "RTN","C0CMAIL2",22,0)
- ;
+ ; DETAIL^C0CMAIL(.C0CDATA,IEN) --> Get details of the Mail Message and Attachments
 "RTN","C0CMAIL2",23,0)
- ;  ------------------
+ ; GETMSG^C0CMAIL(.C0CDATA,.C0CINPUT)
 "RTN","C0CMAIL2",24,0)
- ;Entry Points
+ ;  Input:
 "RTN","C0CMAIL2",25,0)
- ; DETAIL^C0CMAIL(.C0CDATA,IEN) --> Get details of the Mail Message and Attachments
+ ;    C0CINPUT = "DUZ;MAILBOX_Name[or IEN for box (comma Separated);MALL
 "RTN","C0CMAIL2",26,0)
- ; GETMSG^C0CMAIL(.C0CDATA,.C0CINPUT)
+ ;                      or "*" for all boxes, default is "IN" if missing]"
 "RTN","C0CMAIL2",27,0)
- ;  Input:
+ ;                $P(C0CINPUT,";",3)=MALL, default=NUL means "New only",
 "RTN","C0CMAIL2",28,0)
- ;    C0CINPUT = "DUZ;MAILBOX_Name[or IEN for box (comma Separated);MALL
+ ;                                     "*" for All or 9,999 maximum
 "RTN","C0CMAIL2",29,0)
- ;                      or "*" for all boxes, default is "IN" if missing]"
+ ;                    MALL?1.n = that number of the n most recent
 "RTN","C0CMAIL2",30,0)
- ;                $P(C0CINPUT,";",3)=MALL, default=NUL means "New only",
+ ;  Internally:
 "RTN","C0CMAIL2",31,0)
- ;                                     "*" for All or 9,999 maximum
+ ;    BNAM = Box Name
 "RTN","C0CMAIL2",32,0)
- ;                    MALL?1.n = that number of the n most recent
+ ;  Output:
 "RTN","C0CMAIL2",33,0)
- ;  Internally:
+ ;    C0CDATA
 "RTN","C0CMAIL2",34,0)
- ;    BNAM = Box Name
+ ;      = (BNAM,"NUMBER") = Number of NEW Emails in Basket
 "RTN","C0CMAIL2",35,0)
- ;  Output:
+ ;        (BNAM,"MSG",C0CIEN,"FROM")=Name
 "RTN","C0CMAIL2",36,0)
- ;    C0CDATA
+ ;        (BNAM,"MSG",C0CIEN,"TO",n)=DUZ, or EMAIL Address
 "RTN","C0CMAIL2",37,0)
- ;      = (BNAM,"NUMBER") = Number of NEW Emails in Basket
+ ;        (BNAM,"MSG",C0CIEN,"TO NAME",n)=Names or EMAIL Address
 "RTN","C0CMAIL2",38,0)
- ;        (BNAM,"MSG",C0CIEN,"FROM")=Name
+ ;        (BNAM,"MSG",C0CIEN,"TITLE")=EMAIL Title
 "RTN","C0CMAIL2",39,0)
- ;        (BNAM,"MSG",C0CIEN,"TO",n)=DUZ, or EMAIL Address
+ ;        (BNAM,"MSG",C0CIEN[for File 3.9])=Number of Attachments
 "RTN","C0CMAIL2",40,0)
- ;        (BNAM,"MSG",C0CIEN,"TO NAME",n)=Names or EMAIL Address
+ ;        (BNAM,"MSG",C0CIEN,num,"CONT") = Free Text
 "RTN","C0CMAIL2",41,0)
- ;        (BNAM,"MSG",C0CIEN,"TITLE")=EMAIL Title
+ ;        (BNAM,"MSG",C0CIEN,num,"LINES") = Number of Lines of Text
 "RTN","C0CMAIL2",42,0)
- ;        (BNAM,"MSG",C0CIEN[for File 3.9])=Number of Attachments
+ ;        (BNAM,"MSG",C0CIEN,num,"SIZE") = Size of the Message in Bytes
 "RTN","C0CMAIL2",43,0)
- ;        (BNAM,"MSG",C0CIEN,num,"CONT") = Free Text
+ ;        (BNAM,"MSG",C0CIEN,num,"TXT",LINE#) = Message Data (No Attachment)
 "RTN","C0CMAIL2",44,0)
- ;        (BNAM,"MSG",C0CIEN,num,"LINES") = Number of Lines of Text
+ ;   (BNAM,"MSG",C0CIEN,"SEG",NUM) = First Line^Last Line
 "RTN","C0CMAIL2",45,0)
- ;        (BNAM,"MSG",C0CIEN,num,"SIZE") = Size of the Message in Bytes
+ ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,"CONT",type) = Message Details
 "RTN","C0CMAIL2",46,0)
- ;        (BNAM,"MSG",C0CIEN,num,"TXT",LINE#) = Message Data (No Attachment)
+ ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,LINE#) = Message Data
 "RTN","C0CMAIL2",47,0)
- ;   (BNAM,"MSG",C0CIEN,"SEG",NUM) = First Line^Last Line
+ ; 
 "RTN","C0CMAIL2",48,0)
- ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,"CONT",type) = Message Details
+ ; DO DETAIL^C0CMAIL(.OUTBF,D0) ; For each Email Message and Attachments
 "RTN","C0CMAIL2",49,0)
- ;   (BNAM,"MSG",C0CIEN,"SEG",NUM,LINE#) = Message Data
+ ;   Input;
 "RTN","C0CMAIL2",50,0)
+ ;     D0     - The IEN for the message in file 3.9, MESSAGE global
+"RTN","C0CMAIL2",51,0)
+ ;   Output
+"RTN","C0CMAIL2",52,0)
+ ;     OUTBF  - The array of your choice to save the expanded and decoded message.
+"RTN","C0CMAIL2",53,0)
  ; 
-"RTN","C0CMAIL2",51,0)
- ; DO DETAIL^C0CMAIL(.OUTBF,D0) ; For each Email Message and Attachments
-"RTN","C0CMAIL2",52,0)
- ;   Input;
-"RTN","C0CMAIL2",53,0)
- ;     D0     - The IEN for the message in file 3.9, MESSAGE global
 "RTN","C0CMAIL2",54,0)
- ;   Output
+GETMSG(C0CDATA,C0CINPUT) ; Common Entry Point for Mailbox Data
 "RTN","C0CMAIL2",55,0)
- ;     OUTBF  - The array of your choice to save the expanded and decoded message.
+ K:'$G(C0CDATA("KEEP")) C0CDATA
 "RTN","C0CMAIL2",56,0)
- ; 
+ N U
 "RTN","C0CMAIL2",57,0)
-GETMSG(C0CDATA,C0CINPUT) ; Common Entry Point for Mailbox Data
+ S U="^"
 "RTN","C0CMAIL2",58,0)
- K:'$G(C0CDATA("KEEP")) C0CDATA
+ D:$G(C0CINPUT)
 "RTN","C0CMAIL2",59,0)
- N U
+ . N BF,DUZ,I,INPUT,J,L,LST,MBLST,MALL
 "RTN","C0CMAIL2",60,0)
- S U="^"
+ . S INPUT=C0CINPUT
 "RTN","C0CMAIL2",61,0)
- D:$G(C0CINPUT)
+ . S DUZ=+INPUT
 "RTN","C0CMAIL2",62,0)
- . N BF,DUZ,I,INPUT,J,L,LST,MBLST,MALL
+ . I $D(^VA(200,DUZ))=0!('$D(^VA(200,DUZ,0)))  D ERROR("ER06")  Q
 "RTN","C0CMAIL2",63,0)
- . S INPUT=C0CINPUT
+ . ;
 "RTN","C0CMAIL2",64,0)
- . S DUZ=+INPUT
+ . D:$D(^XMB(3.7,DUZ,0))#2
 "RTN","C0CMAIL2",65,0)
- . I $D(^VA(200,DUZ))=0!('$D(^VA(200,DUZ,0)))  D ERROR("ER06")  Q
+ . . S MBLST=$P(INPUT,";",2)
 "RTN","C0CMAIL2",66,0)
- . ;
+ . . S MALL=$P(INPUT,";",3) ; New or All Mail Flag
 "RTN","C0CMAIL2",67,0)
- . D:$D(^XMB(3.7,DUZ,0))#2
+ . . S:MALL["*" MALL=99999
 "RTN","C0CMAIL2",68,0)
- . . S MBLST=$P(INPUT,";",2)
+ . . ; Only one of these can be correct
 "RTN","C0CMAIL2",69,0)
- . . S MALL=$P(INPUT,";",3) ; New or All Mail Flag
+ . . D
 "RTN","C0CMAIL2",70,0)
- . . S:MALL["*" MALL=99999
+ . . . ;  If nul, make it "IN" only
 "RTN","C0CMAIL2",71,0)
- . . ; Only one of these can be correct
+ . . . I MBLST="" D  QUIT
 "RTN","C0CMAIL2",72,0)
- . . D
+ . . . . S MBLST("IN")=0,I=0
 "RTN","C0CMAIL2",73,0)
- . . . ;  If nul, make it "IN" only
+ . . . . D GATHER(DUZ,"IN",.LST)
 "RTN","C0CMAIL2",74,0)
- . . . I MBLST="" D  QUIT
+ . . . .QUIT
 "RTN","C0CMAIL2",75,0)
- . . . . S MBLST("IN")=0,I=0
+ . . . ;
 "RTN","C0CMAIL2",76,0)
- . . . . D GATHER(DUZ,"IN",.LST)
+ . . . ;  If "*", Get all Mailboxes and look for New Messages
 "RTN","C0CMAIL2",77,0)
+ . . . I MBLST["*" D  QUIT
+"RTN","C0CMAIL2",78,0)
+ . . . . N NAM,NUM
+"RTN","C0CMAIL2",79,0)
+ . . . . S NUM=0
+"RTN","C0CMAIL2",80,0)
+ . . . . F  S NUM=$O(^XMB(3.7,DUZ,2,NUM)) Q:'NUM  D
+"RTN","C0CMAIL2",81,0)
+ . . . . . S NAM=$P(^XMB(3.7,DUZ,2,NUM,0),U)
+"RTN","C0CMAIL2",82,0)
+ . . . . . D GATHER(DUZ,NAM,.LST)
+"RTN","C0CMAIL2",83,0)
+ . . . . .QUIT
+"RTN","C0CMAIL2",84,0)
  . . . .QUIT
-"RTN","C0CMAIL2",78,0)
+"RTN","C0CMAIL2",85,0)
  . . . ;
-"RTN","C0CMAIL2",79,0)
- . . . ;  If "*", Get all Mailboxes and look for New Messages
-"RTN","C0CMAIL2",80,0)
- . . . I MBLST["*" D  QUIT
-"RTN","C0CMAIL2",81,0)
- . . . . N NAM,NUM
-"RTN","C0CMAIL2",82,0)
- . . . . S NUM=0
-"RTN","C0CMAIL2",83,0)
- . . . . F  S NUM=$O(^XMB(3.7,DUZ,2,NUM)) Q:'NUM  D
-"RTN","C0CMAIL2",84,0)
- . . . . . S NAM=$P(^XMB(3.7,DUZ,2,NUM,0),U)
-"RTN","C0CMAIL2",85,0)
- . . . . . D GATHER(DUZ,NAM,.LST)
 "RTN","C0CMAIL2",86,0)
+ . . . ;  If comma separated, look for mailboxes with new messages
+"RTN","C0CMAIL2",87,0)
+ . . . I $L(MBLST,",")>1 D  QUIT
+"RTN","C0CMAIL2",88,0)
+ . . . . S NAM=""
+"RTN","C0CMAIL2",89,0)
+ . . . . N TN,V
+"RTN","C0CMAIL2",90,0)
+ . . . . F TN=1:1:$L(MBLST,",")  S V=$P(MBLST,",",TN)  D
+"RTN","C0CMAIL2",91,0)
+ . . . . . I $L(V) D   QUIT
+"RTN","C0CMAIL2",92,0)
+ . . . . . . I V S NAM=$P($G(^XMB(3.7,DUZ,2,V,0)),U)
+"RTN","C0CMAIL2",93,0)
+ . . . . . . S:NAM="" NAM=V
+"RTN","C0CMAIL2",94,0)
+ . . . . . . D GATHER(DUZ,NAM,.LST)
+"RTN","C0CMAIL2",95,0)
+ . . . . . .QUIT
+"RTN","C0CMAIL2",96,0)
+ . . . . . ;
+"RTN","C0CMAIL2",97,0)
+ . . . . . D ERROR("ER08")
+"RTN","C0CMAIL2",98,0)
  . . . . .QUIT
-"RTN","C0CMAIL2",87,0)
+"RTN","C0CMAIL2",99,0)
  . . . .QUIT
-"RTN","C0CMAIL2",88,0)
+"RTN","C0CMAIL2",100,0)
  . . . ;
-"RTN","C0CMAIL2",89,0)
- . . . ;  If comma separated, look for mailboxes with new messages
-"RTN","C0CMAIL2",90,0)
- . . . I $L(MBLST,",")>1 D  QUIT
-"RTN","C0CMAIL2",91,0)
- . . . . S NAM=""
-"RTN","C0CMAIL2",92,0)
- . . . . N TN,V
-"RTN","C0CMAIL2",93,0)
- . . . . F TN=1:1:$L(MBLST,",")  S V=$P(MBLST,",",TN)  D
-"RTN","C0CMAIL2",94,0)
- . . . . . I $L(V) D   QUIT
-"RTN","C0CMAIL2",95,0)
- . . . . . . I V S NAM=$P($G(^XMB(3.7,DUZ,2,V,0)),U)
-"RTN","C0CMAIL2",96,0)
- . . . . . . S:NAM="" NAM=V
-"RTN","C0CMAIL2",97,0)
- . . . . . . D GATHER(DUZ,NAM,.LST)
-"RTN","C0CMAIL2",98,0)
- . . . . . .QUIT
-"RTN","C0CMAIL2",99,0)
- . . . . . ;
-"RTN","C0CMAIL2",100,0)
- . . . . . D ERROR("ER08")
 "RTN","C0CMAIL2",101,0)
- . . . . .QUIT
+ . . . ;  If only 1 mailbox named, go get it
 "RTN","C0CMAIL2",102,0)
- . . . .QUIT
+ . . . I $L(MBLST)  D   QUIT
 "RTN","C0CMAIL2",103,0)
- . . . ;
+ . . . . I $D(^XMB(3.7,DUZ,2,"B",MBLST))    D GATHER(DUZ,MBLST,.LST) QUIT
 "RTN","C0CMAIL2",104,0)
- . . . ;  If only 1 mailbox named, go get it
+ . . . . ;
 "RTN","C0CMAIL2",105,0)
- . . . I $L(MBLST)  D   QUIT
+ . . . . D ERROR("ER07")
 "RTN","C0CMAIL2",106,0)
- . . . . I $D(^XMB(3.7,DUZ,2,"B",MBLST))    D GATHER(DUZ,MBLST,.LST) QUIT
+ . . .QUIT
 "RTN","C0CMAIL2",107,0)
- . . . . ;
+ . . MERGE C0CDATA=LST
 "RTN","C0CMAIL2",108,0)
- . . . . D ERROR("ER07")
+ . .QUIT
 "RTN","C0CMAIL2",109,0)
- . . .QUIT
+ .QUIT
 "RTN","C0CMAIL2",110,0)
- . . MERGE C0CDATA=LST
+ QUIT
 "RTN","C0CMAIL2",111,0)
+ ;  ===================
+"RTN","C0CMAIL2",112,0)
+GATHER(DUZ,NAM,LST) ; Gather Data about the Baskets and their mail
+"RTN","C0CMAIL2",113,0)
+ N I,J,K,L
+"RTN","C0CMAIL2",114,0)
+ S (I,K)=0
+"RTN","C0CMAIL2",115,0)
+ S J=$O(^XMB(3.7,DUZ,2,"B",NAM,""))
+"RTN","C0CMAIL2",116,0)
+ F  S I=$O(^XMB(3.7,DUZ,2,J,1,I)) Q:'I  D
+"RTN","C0CMAIL2",117,0)
+ . S L=$P(^XMB(3.7,DUZ,2,J,1,I,0),U,3)
+"RTN","C0CMAIL2",118,0)
+ . D   ; :L
+"RTN","C0CMAIL2",119,0)
+ . . S:L K=K+1,LST(NAM,"MSG",I,"NEW")=""  ; Flag NEW emails
+"RTN","C0CMAIL2",120,0)
+ . . S LST(NAM,"MSG",I)=L
+"RTN","C0CMAIL2",121,0)
+ . . D GETTYP(I)
+"RTN","C0CMAIL2",122,0)
  . .QUIT
-"RTN","C0CMAIL2",112,0)
+"RTN","C0CMAIL2",123,0)
  .QUIT
-"RTN","C0CMAIL2",113,0)
+"RTN","C0CMAIL2",124,0)
+ S LST(NAM,"NUMBER")=K
+"RTN","C0CMAIL2",125,0)
  QUIT
-"RTN","C0CMAIL2",114,0)
+"RTN","C0CMAIL2",126,0)
  ;  ===================
-"RTN","C0CMAIL2",115,0)
-GATHER(DUZ,NAM,LST) ; Gather Data about the Baskets and their mail
-"RTN","C0CMAIL2",116,0)
- N I,J,K,L
-"RTN","C0CMAIL2",117,0)
- S (I,K)=0
-"RTN","C0CMAIL2",118,0)
- S J=$O(^XMB(3.7,DUZ,2,"B",NAM,""))
-"RTN","C0CMAIL2",119,0)
- F  S I=$O(^XMB(3.7,DUZ,2,J,1,I)) Q:'I  D
-"RTN","C0CMAIL2",120,0)
- . S L=$P(^XMB(3.7,DUZ,2,J,1,I,0),U,3)
-"RTN","C0CMAIL2",121,0)
- . D   ; :L
-"RTN","C0CMAIL2",122,0)
- . . S:L K=K+1,LST(NAM,"MSG",I,"NEW")=""  ; Flag NEW emails
-"RTN","C0CMAIL2",123,0)
- . . S LST(NAM,"MSG",I)=L
-"RTN","C0CMAIL2",124,0)
- . . D GETTYP(I)
-"RTN","C0CMAIL2",125,0)
- . .QUIT
-"RTN","C0CMAIL2",126,0)
- .QUIT
 "RTN","C0CMAIL2",127,0)
- S LST(NAM,"NUMBER")=K
+ ; D0 is the IEN into the Message Global ^XMB(3.9,D0)
 "RTN","C0CMAIL2",128,0)
- QUIT
+ ; The products of these emails are scanned to identify
 "RTN","C0CMAIL2",129,0)
- ;  ===================
+ ;  the number of documents stored in the MIME package.
 "RTN","C0CMAIL2",130,0)
- ; D0 is the IEN into the Message Global ^XMB(3.9,D0)
+ ;  The protocol runs like this;
 "RTN","C0CMAIL2",131,0)
- ; The products of these emails are scanned to identify
+ ; Line 1 is the --separator
 "RTN","C0CMAIL2",132,0)
- ;  the number of documents stored in the MIME package.
+ ; Line 2 thru n >Look for Content-[detail type:]Description ; Next CMD
 "RTN","C0CMAIL2",133,0)
- ;  The protocol runs like this;
+ ; Line n+2 thru t-1 where t does NOT have "Content-"
 "RTN","C0CMAIL2",134,0)
- ; Line 1 is the --separator
+ ; Line t   is Next Section Terminator, or Message Terminator, --separator
 "RTN","C0CMAIL2",135,0)
- ; Line 2 thru n >Look for Content-[detail type:]Description ; Next CMD
+ ; Line t+1 should not exist in the data set if Message Terminator
 "RTN","C0CMAIL2",136,0)
- ; Line n+2 thru t-1 where t does NOT have "Content-"
+ ; CON = "Content-"
 "RTN","C0CMAIL2",137,0)
- ; Line t   is Next Section Terminator, or Message Terminator, --separator
+ ; FLG = "--"
 "RTN","C0CMAIL2",138,0)
- ; Line t+1 should not exist in the data set if Message Terminator
+ ; SEP = FLG+7 or more characters  ; Separator
 "RTN","C0CMAIL2",139,0)
- ; CON = "Content-"
+ ; END = SEP+FLG
 "RTN","C0CMAIL2",140,0)
- ; FLG = "--"
+ ; SGC = Segment Count
 "RTN","C0CMAIL2",141,0)
- ; SEP = FLG+7 or more characters  ; Separator
+ ; Note: separator is a string of specific characters of
 "RTN","C0CMAIL2",142,0)
- ; END = SEP+FLG
+ ;        indeterminate length  
 "RTN","C0CMAIL2",143,0)
- ; SGC = Segment Count
+ ; LST() the transfer array
 "RTN","C0CMAIL2",144,0)
- ; Note: separator is a string of specific characters of
+ ; LST(NAM,"MSG",C0CIEN,"SEG",SGN)=Starting Line^Ending Line
 "RTN","C0CMAIL2",145,0)
- ;        indeterminate length  
+ ; LST(NAM,"MSG",C0CIEN,"SEG",SGN,1:n)=Decoded Message Data
 "RTN","C0CMAIL2",146,0)
- ; LST() the transfer array
+ ;
 "RTN","C0CMAIL2",147,0)
- ; LST(NAM,"MSG",C0CIEN,"SEG",SGN)=Starting Line^Ending Line
+GETTYP(D0) ; Look for the goodies in the Mail
 "RTN","C0CMAIL2",148,0)
- ; LST(NAM,"MSG",C0CIEN,"SEG",SGN,1:n)=Decoded Message Data
+ N I,J,N,BCN,CON,CNT,D1,END,FLG,SEP,SGC,XX,XXNM
 "RTN","C0CMAIL2",149,0)
- ;
+ S CON="Content-"
 "RTN","C0CMAIL2",150,0)
-GETTYP(D0) ; Look for the goodies in the Mail
+ S FLG="--"
 "RTN","C0CMAIL2",151,0)
- N I,J,N,BCN,CON,CNT,D1,END,FLG,SEP,SGC,XX,XXNM
+ S SEP=""  ; Start SEP as null, so we can use this to help identify the type
 "RTN","C0CMAIL2",152,0)
- S CON="Content-"
+ S (BCN,CNT,D1,END,SGC)=0
 "RTN","C0CMAIL2",153,0)
- S FLG="--"
+ S XX=$G(^XMB(3.9,D0,0))
 "RTN","C0CMAIL2",154,0)
- S SEP=""  ; Start SEP as null, so we can use this to help identify the type
+ S LST(NAM,"MSG",D0,"TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
 "RTN","C0CMAIL2",155,0)
- S (BCN,CNT,D1,END,SGC)=0
+ S LST(NAM,"MSG",D0,"CREATED")=$G(^XMB(3.9,D0,.6))
 "RTN","C0CMAIL2",156,0)
- S XX=$G(^XMB(3.9,D0,0))
+ F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
 "RTN","C0CMAIL2",157,0)
- S LST(NAM,"MSG",D0,"TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
+ S LST(NAM,"MSG",D0,"FROM")=$$NAME(XXNM)
 "RTN","C0CMAIL2",158,0)
- S LST(NAM,"MSG",D0,"CREATED")=$G(^XMB(3.9,D0,.6))
+ S LST(NAM,"MSG",D0,"SENT")=$$TIME($P(XX,U,3))
 "RTN","C0CMAIL2",159,0)
- F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
+ ; Get the folks the email is sent to.
 "RTN","C0CMAIL2",160,0)
- S LST(NAM,"MSG",D0,"FROM")=$$NAME(XXNM)
+ S D1=0
 "RTN","C0CMAIL2",161,0)
- S LST(NAM,"MSG",D0,"SENT")=$$TIME($P(XX,U,3))
+ F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D
 "RTN","C0CMAIL2",162,0)
- ; Get the folks the email is sent to.
+ . N T
 "RTN","C0CMAIL2",163,0)
- S D1=0
+ . S T=+$G(^XMB(3.9,D0,1,D1,0))
 "RTN","C0CMAIL2",164,0)
- F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D
+ . S:T T=$P($G(^VA(200,+T,0)),"^")
 "RTN","C0CMAIL2",165,0)
- . N T
+ . S LST("TO",D1)=T
 "RTN","C0CMAIL2",166,0)
- . S T=+$G(^XMB(3.9,D0,1,D1,0))
+ . S T=$G(^XMB(3.9,D0,6,D1,0))
 "RTN","C0CMAIL2",167,0)
  . S:T T=$P($G(^VA(200,+T,0)),"^")
 "RTN","C0CMAIL2",168,0)
- . S LST("TO",D1)=T
+ . S:T="" T="<Unknown>"
 "RTN","C0CMAIL2",169,0)
- . S T=$G(^XMB(3.9,D0,6,D1,0))
+ . S LST("TO NAME",D1)=T
 "RTN","C0CMAIL2",170,0)
- . S:T T=$P($G(^VA(200,+T,0)),"^")
+ .QUIT
 "RTN","C0CMAIL2",171,0)
- . S:T="" T="<Unknown>"
+ ; Preload first Segment (0) with beginning on Line 1
 "RTN","C0CMAIL2",172,0)
- . S LST("TO NAME",D1)=T
+ ;  if not a 64bit
 "RTN","C0CMAIL2",173,0)
+ S LST(NAM,"MSG",D0,"SEG",0)=1
+"RTN","C0CMAIL2",174,0)
+ S D1=.9999,SEP="@@"
+"RTN","C0CMAIL2",175,0)
+ F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
+"RTN","C0CMAIL2",176,0)
+ . ; Clear any control characters (cr/lf/ff) off
+"RTN","C0CMAIL2",177,0)
+ . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
+"RTN","C0CMAIL2",178,0)
+ . ; Enter once to set the SEP to capture the separator
+"RTN","C0CMAIL2",179,0)
+ . I SEP=FLG&($E(X,1,2)=FLG)&($L(X,FLG)=2)&($L($P(X,FLG,2)>5))   D   Q
+"RTN","C0CMAIL2",180,0)
+ . . S SEP=X,END=X_FLG
+"RTN","C0CMAIL2",181,0)
+ . . S (CNT,SGC)=1,BCN=0
+"RTN","C0CMAIL2",182,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
+"RTN","C0CMAIL2",183,0)
+ . .QUIT
+"RTN","C0CMAIL2",184,0)
+ . ;
+"RTN","C0CMAIL2",185,0)
+ . ; A new separator is set, process original 
+"RTN","C0CMAIL2",186,0)
+ . I X=SEP  D  QUIT
+"RTN","C0CMAIL2",187,0)
+ . . S LST(NAM,"MSG",D0,SGC,"SIZE")=BCN+$L(BF)
+"RTN","C0CMAIL2",188,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC)=$G(LST(NAM,"MSG",D0,"SEG",SGC))_"^"_(D1-1)
+"RTN","C0CMAIL2",189,0)
+ . . S SGC=SGC+1,BCN=0
+"RTN","C0CMAIL2",190,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
+"RTN","C0CMAIL2",191,0)
+ . .QUIT
+"RTN","C0CMAIL2",192,0)
+ . ;
+"RTN","C0CMAIL2",193,0)
+ . S BCN=BCN+$L(X)
+"RTN","C0CMAIL2",194,0)
+ . I X[CON D  Q
+"RTN","C0CMAIL2",195,0)
+ . . S J=$P($P(X,";"),CON,2)
+"RTN","C0CMAIL2",196,0)
+ . . S LST(NAM,"MSG",D0,"SEG",SGC,"CONT",CNT,$P(J,":"))=$P(J,":",2)
+"RTN","C0CMAIL2",197,0)
+ . .QUIT
+"RTN","C0CMAIL2",198,0)
+ . ;
+"RTN","C0CMAIL2",199,0)
+ . ; S LST(NAM,"MSG",D0,"SEG",D1)=X
+"RTN","C0CMAIL2",200,0)
  .QUIT
-"RTN","C0CMAIL2",174,0)
- ; Preload first Segment (0) with beginning on Line 1
-"RTN","C0CMAIL2",175,0)
- ;  if not a 64bit
-"RTN","C0CMAIL2",176,0)
- S LST(NAM,"MSG",D0,"SEG",0)=1
-"RTN","C0CMAIL2",177,0)
- S D1=.9999,SEP="@@"
-"RTN","C0CMAIL2",178,0)
- F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
-"RTN","C0CMAIL2",179,0)
- . ; Clear any control characters (cr/lf/ff) off
-"RTN","C0CMAIL2",180,0)
- . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
-"RTN","C0CMAIL2",181,0)
- . ; Enter once to set the SEP to capture the separator
-"RTN","C0CMAIL2",182,0)
- . I SEP=FLG&($E(X,1,2)=FLG)&($L(X,FLG)=2)&($L($P(X,FLG,2)>5))   D   Q
-"RTN","C0CMAIL2",183,0)
- . . S SEP=X,END=X_FLG
-"RTN","C0CMAIL2",184,0)
- . . S (CNT,SGC)=1,BCN=0
-"RTN","C0CMAIL2",185,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
-"RTN","C0CMAIL2",186,0)
- . .QUIT
-"RTN","C0CMAIL2",187,0)
+"RTN","C0CMAIL2",201,0)
+ QUIT
+"RTN","C0CMAIL2",202,0)
+ ;  ===================
+"RTN","C0CMAIL2",203,0)
+NAME(NM) ; Return the name of the Sender
+"RTN","C0CMAIL2",204,0)
+ N NAME
+"RTN","C0CMAIL2",205,0)
+ S NAME="<Unknown Sender>"
+"RTN","C0CMAIL2",206,0)
+ D
+"RTN","C0CMAIL2",207,0)
+ . ; Look first for a value to use with the NEW PERSON file
+"RTN","C0CMAIL2",208,0)
  . ;
-"RTN","C0CMAIL2",188,0)
- . ; A new separator is set, process original 
-"RTN","C0CMAIL2",189,0)
- . I X=SEP  D  QUIT
-"RTN","C0CMAIL2",190,0)
- . . S LST(NAM,"MSG",D0,SGC,"SIZE")=BCN+$L(BF)
-"RTN","C0CMAIL2",191,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC)=$G(LST(NAM,"MSG",D0,"SEG",SGC))_"^"_(D1-1)
-"RTN","C0CMAIL2",192,0)
- . . S SGC=SGC+1,BCN=0
-"RTN","C0CMAIL2",193,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC)=D1
-"RTN","C0CMAIL2",194,0)
- . .QUIT
-"RTN","C0CMAIL2",195,0)
+"RTN","C0CMAIL2",209,0)
+ . I NM=+NM S NAME=$P(^VA(200,NM,0),U,1) Q
+"RTN","C0CMAIL2",210,0)
  . ;
-"RTN","C0CMAIL2",196,0)
- . S BCN=BCN+$L(X)
-"RTN","C0CMAIL2",197,0)
- . I X[CON D  Q
-"RTN","C0CMAIL2",198,0)
- . . S J=$P($P(X,";"),CON,2)
-"RTN","C0CMAIL2",199,0)
- . . S LST(NAM,"MSG",D0,"SEG",SGC,"CONT",CNT,$P(J,":"))=$P(J,":",2)
-"RTN","C0CMAIL2",200,0)
- . .QUIT
-"RTN","C0CMAIL2",201,0)
+"RTN","C0CMAIL2",211,0)
+ . I $L(NM) S NAME=NM                    Q
+"RTN","C0CMAIL2",212,0)
  . ;
-"RTN","C0CMAIL2",202,0)
- . ; S LST(NAM,"MSG",D0,"SEG",D1)=X
-"RTN","C0CMAIL2",203,0)
+"RTN","C0CMAIL2",213,0)
+ . ; Else, pull the data from the message and display the foreign source
+"RTN","C0CMAIL2",214,0)
+ . ;   of the message.
+"RTN","C0CMAIL2",215,0)
+ . N T
+"RTN","C0CMAIL2",216,0)
+ . S VAL=$G(^XMB(3.9,D0,.7))
+"RTN","C0CMAIL2",217,0)
+ . S:VAL T=$P(^VA(200,VAL,0),U)
+"RTN","C0CMAIL2",218,0)
+ . I $L($G(T)) S NAME=T                  Q
+"RTN","C0CMAIL2",219,0)
+ . ;
+"RTN","C0CMAIL2",220,0)
  .QUIT
-"RTN","C0CMAIL2",204,0)
- QUIT
-"RTN","C0CMAIL2",205,0)
+"RTN","C0CMAIL2",221,0)
+ QUIT NAME
+"RTN","C0CMAIL2",222,0)
  ;  ===================
-"RTN","C0CMAIL2",206,0)
-NAME(NM) ; Return the name of the Sender
-"RTN","C0CMAIL2",207,0)
- N NAME
-"RTN","C0CMAIL2",208,0)
- S NAME="<Unknown Sender>"
-"RTN","C0CMAIL2",209,0)
- D
-"RTN","C0CMAIL2",210,0)
- . ; Look first for a value to use with the NEW PERSON file
-"RTN","C0CMAIL2",211,0)
+"RTN","C0CMAIL2",223,0)
+TIME(Y) ; The time and date of the sending
+"RTN","C0CMAIL2",224,0)
+ X ^DD("DD")
+"RTN","C0CMAIL2",225,0)
+ QUIT Y
+"RTN","C0CMAIL2",226,0)
+ ;  ===================
+"RTN","C0CMAIL2",227,0)
+ ;  Segments in Message need to be identified and decoded properly
+"RTN","C0CMAIL2",228,0)
+ ; D DETAIL^C0CMAIL(.ARRAY,D0) ;  Call One for each message
+"RTN","C0CMAIL2",229,0)
+ ;   ARRAY will have the details of this one call
+"RTN","C0CMAIL2",230,0)
+ ;    
+"RTN","C0CMAIL2",231,0)
+ ; Inputs;
+"RTN","C0CMAIL2",232,0)
+ ;   C0CINPUT    - The IEN of the message to expand
+"RTN","C0CMAIL2",233,0)
+ ; Outputs;
+"RTN","C0CMAIL2",234,0)
+ ;   C0CDATA     - Carrier for the returned structure of the Message
+"RTN","C0CMAIL2",235,0)
+ ;  C0CDATA(D0,"SEG")=number of SEGMENTS
+"RTN","C0CMAIL2",236,0)
+ ;  C0CDATA(D0,"SEG",0:n)=SEGMENT n details; First;Last;Type
+"RTN","C0CMAIL2",237,0)
+ ;  C0CDATA(D0,"SEG",0:n,"CONTENT",type)=Content details
+"RTN","C0CMAIL2",238,0)
+ ;  C0CDATA(D0,"SEG",0:n,"MSG",D3)=Content details
+"RTN","C0CMAIL2",239,0)
+ ;  C0CDATA(D0,"SEG",0:n,"HTML",D3)=Content details
+"RTN","C0CMAIL2",240,0)
+ ;
+"RTN","C0CMAIL2",241,0)
+DETAIL(C0CDATA,C0CINPUT) ; Message Detail Delivery
+"RTN","C0CMAIL2",242,0)
+ N LST,D0,D1,U
+"RTN","C0CMAIL2",243,0)
+ S U="^"
+"RTN","C0CMAIL2",244,0)
+ S D0=+$G(C0CINPUT)
+"RTN","C0CMAIL2",245,0)
+ I D0   D    QUIT
+"RTN","C0CMAIL2",246,0)
+ . I $D(^XMB(3.9,D0))<10 D ERROR("ER01")  QUIT
+"RTN","C0CMAIL2",247,0)
  . ;
-"RTN","C0CMAIL2",212,0)
- . I NM=+NM S NAME=$P(^VA(200,NM,0),U,1) Q
-"RTN","C0CMAIL2",213,0)
- . ;
-"RTN","C0CMAIL2",214,0)
- . I $L(NM) S NAME=NM                    Q
-"RTN","C0CMAIL2",215,0)
- . ;
-"RTN","C0CMAIL2",216,0)
- . ; Else, pull the data from the message and display the foreign source
-"RTN","C0CMAIL2",217,0)
- . ;   of the message.
-"RTN","C0CMAIL2",218,0)
- . N T
-"RTN","C0CMAIL2",219,0)
- . S VAL=$G(^XMB(3.9,D0,.7))
-"RTN","C0CMAIL2",220,0)
- . S:VAL T=$P(^VA(200,VAL,0),U)
-"RTN","C0CMAIL2",221,0)
- . I $L($G(T)) S NAME=T                  Q
-"RTN","C0CMAIL2",222,0)
- . ;
-"RTN","C0CMAIL2",223,0)
- .QUIT
-"RTN","C0CMAIL2",224,0)
- QUIT NAME
-"RTN","C0CMAIL2",225,0)
- ;  ===================
-"RTN","C0CMAIL2",226,0)
-TIME(Y) ; The time and date of the sending
-"RTN","C0CMAIL2",227,0)
- X ^DD("DD")
-"RTN","C0CMAIL2",228,0)
- QUIT Y
-"RTN","C0CMAIL2",229,0)
- ;  ===================
-"RTN","C0CMAIL2",230,0)
- ;  Segments in Message need to be identified and decoded properly
-"RTN","C0CMAIL2",231,0)
- ; D DETAIL^C0CMAIL(.ARRAY,D0) ;  Call One for each message
-"RTN","C0CMAIL2",232,0)
- ;   ARRAY will have the details of this one call
-"RTN","C0CMAIL2",233,0)
- ;    
-"RTN","C0CMAIL2",234,0)
- ; Inputs;
-"RTN","C0CMAIL2",235,0)
- ;   C0CINPUT    - The IEN of the message to expand
-"RTN","C0CMAIL2",236,0)
- ; Outputs;
-"RTN","C0CMAIL2",237,0)
- ;   C0CDATA     - Carrier for the returned structure of the Message
-"RTN","C0CMAIL2",238,0)
- ;  C0CDATA(D0,"SEG")=number of SEGMENTS
-"RTN","C0CMAIL2",239,0)
- ;  C0CDATA(D0,"SEG",0:n)=SEGMENT n details; First;Last;Type
-"RTN","C0CMAIL2",240,0)
- ;  C0CDATA(D0,"SEG",0:n,"CONTENT",type)=Content details
-"RTN","C0CMAIL2",241,0)
- ;  C0CDATA(D0,"SEG",0:n,"MSG",D3)=Content details
-"RTN","C0CMAIL2",242,0)
- ;  C0CDATA(D0,"SEG",0:n,"HTML",D3)=Content details
-"RTN","C0CMAIL2",243,0)
- ;
-"RTN","C0CMAIL2",244,0)
-DETAIL(C0CDATA,C0CINPUT) ; Message Detail Delivery
-"RTN","C0CMAIL2",245,0)
- N LST,D0,D1,U
-"RTN","C0CMAIL2",246,0)
- S U="^"
-"RTN","C0CMAIL2",247,0)
- S D0=+$G(C0CINPUT)
 "RTN","C0CMAIL2",248,0)
- I D0   D    QUIT
+ . D GETTYP2(D0)
 "RTN","C0CMAIL2",249,0)
- . I $D(^XMB(3.9,D0))<10 D ERROR("ER01")  QUIT
+ . I $D(LST)   M C0CDATA(D0)=LST  Q
 "RTN","C0CMAIL2",250,0)
  . ;
 "RTN","C0CMAIL2",251,0)
- . D GETTYP2(D0)
+ . D ERROR("ER02")
 "RTN","C0CMAIL2",252,0)
- . I $D(LST)   M C0CDATA(D0)=LST  Q
+ .QUIT
 "RTN","C0CMAIL2",253,0)
+ QUIT
+"RTN","C0CMAIL2",254,0)
+ ;  ===================
+"RTN","C0CMAIL2",255,0)
+ ;  End note if needed
+"RTN","C0CMAIL2",256,0)
+ ; MSK   - Set of characters that do not exist in 64 bit encoding
+"RTN","C0CMAIL2",257,0)
+GETTYP2(D0) ; Try to get the types and MSK for the 
+"RTN","C0CMAIL2",258,0)
+ N I,J,K,N,BCN,BF,CON,CNT,D1,END,FLG,MSK,SEP,SGC,U,XX,ZN,XXNM
+"RTN","C0CMAIL2",259,0)
+ S CON="Content-",U="^"
+"RTN","C0CMAIL2",260,0)
+ S FLG="--"
+"RTN","C0CMAIL2",261,0)
+ S MSK=" !""#$%&'()*,-.:;<>?@[\]^_`{|}~"
+"RTN","C0CMAIL2",262,0)
+ S (BF,SEP)=""  ; Start SEP as null, so we can use this to help identify the type
+"RTN","C0CMAIL2",263,0)
+ S (BCN,CNT,D1,END,SGC)=0
+"RTN","C0CMAIL2",264,0)
+ S XX=$G(^XMB(3.9,D0,0))
+"RTN","C0CMAIL2",265,0)
+ ; S K=$P(^XMB(3.9,D0,2,0),U,3)
+"RTN","C0CMAIL2",266,0)
+ S LST("TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
+"RTN","C0CMAIL2",267,0)
+ S LST("CREATED")=$$TIME($P(XX,U,3))
+"RTN","C0CMAIL2",268,0)
+ F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
+"RTN","C0CMAIL2",269,0)
+ S LST("FROM")=$$NAME(XXNM)
+"RTN","C0CMAIL2",270,0)
+ ; Get the folks the email is sent to.
+"RTN","C0CMAIL2",271,0)
+ S D1=0
+"RTN","C0CMAIL2",272,0)
+ F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D   Q:D1=""
+"RTN","C0CMAIL2",273,0)
+ . N I,T
+"RTN","C0CMAIL2",274,0)
+ . S T=$P($G(^XMB(3.9,D0,1,D1,0)),U)
+"RTN","C0CMAIL2",275,0)
+ . S:T T=$P($G(^VA(200,T,0)),"^")
+"RTN","C0CMAIL2",276,0)
+ . S LST("TO",+D1)=T
+"RTN","C0CMAIL2",277,0)
+ . S T=$G(^XMB(3.9,D0,6,+D1,0))
+"RTN","C0CMAIL2",278,0)
+ . S:T="" T=$P($G(^VA(200,+T,0)),"^")
+"RTN","C0CMAIL2",279,0)
+ . S:T="" T="<Unknown>"
+"RTN","C0CMAIL2",280,0)
+ . S LST("TO NAME",D1)=T
+"RTN","C0CMAIL2",281,0)
+ .QUIT
+"RTN","C0CMAIL2",282,0)
+ ; Get the Header for the message
+"RTN","C0CMAIL2",283,0)
+ S D1=0
+"RTN","C0CMAIL2",284,0)
+ F I=1:1 S D1=$O(^XMB(3.9,D0,2,D1)) Q:D1=""  Q:(D1>.99999)   D
+"RTN","C0CMAIL2",285,0)
+ . S LST("HDR",I)=$G(^XMB(3.9,D0,2,D1,0))
+"RTN","C0CMAIL2",286,0)
+ .QUIT
+"RTN","C0CMAIL2",287,0)
+ ; Start walking the different sections
+"RTN","C0CMAIL2",288,0)
+ S D1=.99999,SEP="@@",SGC=0
+"RTN","C0CMAIL2",289,0)
+ F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
+"RTN","C0CMAIL2",290,0)
+ . ; Clear any control characters (cr/lf/ff) off
+"RTN","C0CMAIL2",291,0)
+ . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
+"RTN","C0CMAIL2",292,0)
+ . ; Enter once to set the SEP to capture the separator
+"RTN","C0CMAIL2",293,0)
+ . I (SEP="@@")&(X?2."--"5.AN.E)  D   Q
+"RTN","C0CMAIL2",294,0)
+ . . I $L(X,FLG)>2 D ERROR("ER10")
+"RTN","C0CMAIL2",295,0)
+ . . S SEP=X,END=X_FLG
+"RTN","C0CMAIL2",296,0)
+ . . S (CNT,SGC)=1,BCN=0
+"RTN","C0CMAIL2",297,0)
+ . . S LST("SEG",SGC)=D1
+"RTN","C0CMAIL2",298,0)
+ . .QUIT
+"RTN","C0CMAIL2",299,0)
  . ;
-"RTN","C0CMAIL2",254,0)
- . D ERROR("ER02")
-"RTN","C0CMAIL2",255,0)
- .QUIT
-"RTN","C0CMAIL2",256,0)
- QUIT
-"RTN","C0CMAIL2",257,0)
- ;  ===================
-"RTN","C0CMAIL2",258,0)
- ;  End note if needed
-"RTN","C0CMAIL2",259,0)
- ; MSK   - Set of characters that do not exist in 64 bit encoding
-"RTN","C0CMAIL2",260,0)
-GETTYP2(D0) ; Try to get the types and MSK for the 
-"RTN","C0CMAIL2",261,0)
- N I,J,K,N,BCN,BF,CON,CNT,D1,END,FLG,MSK,SEP,SGC,U,XX,ZN,XXNM
-"RTN","C0CMAIL2",262,0)
- S CON="Content-",U="^"
-"RTN","C0CMAIL2",263,0)
- S FLG="--"
-"RTN","C0CMAIL2",264,0)
- S MSK=" !""#$%&'()*,-.:;<>?@[\]^_`{|}~"
-"RTN","C0CMAIL2",265,0)
- S (BF,SEP)=""  ; Start SEP as null, so we can use this to help identify the type
-"RTN","C0CMAIL2",266,0)
- S (BCN,CNT,D1,END,SGC)=0
-"RTN","C0CMAIL2",267,0)
- S XX=$G(^XMB(3.9,D0,0))
-"RTN","C0CMAIL2",268,0)
- ; S K=$P(^XMB(3.9,D0,2,0),U,3)
-"RTN","C0CMAIL2",269,0)
- S LST("TITLE")=$P($G(^XMB(3.9,D0,0)),U,1)
-"RTN","C0CMAIL2",270,0)
- S LST("CREATED")=$$TIME($P(XX,U,3))
-"RTN","C0CMAIL2",271,0)
- F I=4,2 S XXNM=$P(XX,U,I)  Q:$L(XXNM)
-"RTN","C0CMAIL2",272,0)
- S LST("FROM")=$$NAME(XXNM)
-"RTN","C0CMAIL2",273,0)
- ; Get the folks the email is sent to.
-"RTN","C0CMAIL2",274,0)
- S D1=0
-"RTN","C0CMAIL2",275,0)
- F  S D1=$O(^XMB(3.9,D0,1,D1)) Q:'D1  D   Q:D1=""
-"RTN","C0CMAIL2",276,0)
- . N I,T
-"RTN","C0CMAIL2",277,0)
- . S T=$P($G(^XMB(3.9,D0,1,D1,0)),U)
-"RTN","C0CMAIL2",278,0)
- . S:T T=$P($G(^VA(200,T,0)),"^")
-"RTN","C0CMAIL2",279,0)
- . S LST("TO",+D1)=T
-"RTN","C0CMAIL2",280,0)
- . S T=$G(^XMB(3.9,D0,6,+D1,0))
-"RTN","C0CMAIL2",281,0)
- . S:T="" T=$P($G(^VA(200,+T,0)),"^")
-"RTN","C0CMAIL2",282,0)
- . S:T="" T="<Unknown>"
-"RTN","C0CMAIL2",283,0)
- . S LST("TO NAME",D1)=T
-"RTN","C0CMAIL2",284,0)
- .QUIT
-"RTN","C0CMAIL2",285,0)
- ; Get the Header for the message
-"RTN","C0CMAIL2",286,0)
- S D1=0
-"RTN","C0CMAIL2",287,0)
- F I=1:1 S D1=$O(^XMB(3.9,D0,2,D1)) Q:D1=""  Q:(D1>.99999)   D
-"RTN","C0CMAIL2",288,0)
- . S LST("HDR",I)=$G(^XMB(3.9,D0,2,D1,0))
-"RTN","C0CMAIL2",289,0)
- .QUIT
-"RTN","C0CMAIL2",290,0)
- ; Start walking the different sections
-"RTN","C0CMAIL2",291,0)
- S D1=.99999,SEP="@@",SGC=0
-"RTN","C0CMAIL2",292,0)
- F  S D1=$O(^XMB(3.9,D0,2,D1)) Q:'D1  D
-"RTN","C0CMAIL2",293,0)
- . ; Clear any control characters (cr/lf/ff) off
-"RTN","C0CMAIL2",294,0)
- . S X=$TR($G(^XMB(3.9,D0,2,D1,0)),$C(10,12,13))
-"RTN","C0CMAIL2",295,0)
- . ; Enter once to set the SEP to capture the separator
-"RTN","C0CMAIL2",296,0)
- . I (SEP="@@")&(X?2."--"5.AN.E)  D   Q
-"RTN","C0CMAIL2",297,0)
- . . I $L(X,FLG)>2 D ERROR("ER10")
-"RTN","C0CMAIL2",298,0)
- . . S SEP=X,END=X_FLG
-"RTN","C0CMAIL2",299,0)
- . . S (CNT,SGC)=1,BCN=0
 "RTN","C0CMAIL2",300,0)
+ . ; A new SEGMENT separator is set, process original 
+"RTN","C0CMAIL2",301,0)
+ . I X=SEP  D  QUIT
+"RTN","C0CMAIL2",302,0)
+ . . ; Save Current Values
+"RTN","C0CMAIL2",303,0)
+ . . S LST("SEG",SGC,"SIZE")=BCN+$L(BF)
+"RTN","C0CMAIL2",304,0)
+ . . ;  Close this Segment and prepare to start a New Segment
+"RTN","C0CMAIL2",305,0)
+ . . S $P(LST("SEG",SGC),"^",1,2)=$P($G(LST("SEG",SGC)),"^",1)_"^"_(D1-1)
+"RTN","C0CMAIL2",306,0)
+ . . ;  Put the result in LST("SEG",SGC,"XML")
+"RTN","C0CMAIL2",307,0)
+ . . I $L(BF) D
+"RTN","C0CMAIL2",308,0)
+ . . . S ZN=1
+"RTN","C0CMAIL2",309,0)
+ . . . N I,T,TBF
+"RTN","C0CMAIL2",310,0)
+ . . . S TBF=BF
+"RTN","C0CMAIL2",311,0)
+ . . . F I=1:1:($L(TBF,"="))  D
+"RTN","C0CMAIL2",312,0)
+ . . . . S BF=$P(TBF,"=",I)_"="
+"RTN","C0CMAIL2",313,0)
+ . . . . I BF'="="  D DECODER
+"RTN","C0CMAIL2",314,0)
+ . . . .QUIT
+"RTN","C0CMAIL2",315,0)
+ . . . S BF=""
+"RTN","C0CMAIL2",316,0)
+ . . .QUIT
+"RTN","C0CMAIL2",317,0)
+ . . S SGC=SGC+1,BCN=0
+"RTN","C0CMAIL2",318,0)
+ . . ; Incriment SGC to start a new Segment
+"RTN","C0CMAIL2",319,0)
  . . S LST("SEG",SGC)=D1
-"RTN","C0CMAIL2",301,0)
+"RTN","C0CMAIL2",320,0)
  . .QUIT
-"RTN","C0CMAIL2",302,0)
+"RTN","C0CMAIL2",321,0)
  . ;
-"RTN","C0CMAIL2",303,0)
- . ; A new SEGMENT separator is set, process original 
-"RTN","C0CMAIL2",304,0)
- . I X=SEP  D  QUIT
-"RTN","C0CMAIL2",305,0)
- . . ; Save Current Values
-"RTN","C0CMAIL2",306,0)
- . . S LST("SEG",SGC,"SIZE")=BCN+$L(BF)
-"RTN","C0CMAIL2",307,0)
- . . ;  Close this Segment and prepare to start a New Segment
-"RTN","C0CMAIL2",308,0)
- . . S $P(LST("SEG",SGC),"^",1,2)=$P($G(LST("SEG",SGC)),"^",1)_"^"_(D1-1)
-"RTN","C0CMAIL2",309,0)
- . . ;  Put the result in LST("SEG",SGC,"XML")
-"RTN","C0CMAIL2",310,0)
- . . I $L(BF) D
-"RTN","C0CMAIL2",311,0)
- . . . S ZN=1
-"RTN","C0CMAIL2",312,0)
- . . . N I,T,TBF
-"RTN","C0CMAIL2",313,0)
- . . . S TBF=BF
-"RTN","C0CMAIL2",314,0)
- . . . F I=1:1:($L(TBF,"="))  D
-"RTN","C0CMAIL2",315,0)
- . . . . S BF=$P(TBF,"=",I)_"="
-"RTN","C0CMAIL2",316,0)
- . . . . I BF'="="  D DECODER
-"RTN","C0CMAIL2",317,0)
- . . . .QUIT
-"RTN","C0CMAIL2",318,0)
- . . . S BF=""
-"RTN","C0CMAIL2",319,0)
- . . .QUIT
-"RTN","C0CMAIL2",320,0)
- . . S SGC=SGC+1,BCN=0
-"RTN","C0CMAIL2",321,0)
- . . ; Incriment SGC to start a new Segment
 "RTN","C0CMAIL2",322,0)
- . . S LST("SEG",SGC)=D1
+ . ; Accumulate the 64 bit encoding
 "RTN","C0CMAIL2",323,0)
- . .QUIT
+ . I X=$TR(X,MSK)&$L(X)  S BF=BF_X  QUIT
 "RTN","C0CMAIL2",324,0)
  . ;
 "RTN","C0CMAIL2",325,0)
- . ; Accumulate the 64 bit encoding
+ . ; Ending Condition, close out the Segment
 "RTN","C0CMAIL2",326,0)
- . I X=$TR(X,MSK)&$L(X)  S BF=BF_X  QUIT
+ . I X=END D  QUIT
 "RTN","C0CMAIL2",327,0)
+ . . S LST("SEG",SGC)=$G(LST("SEG",SGC))_"^"_(D1-1)
+"RTN","C0CMAIL2",328,0)
+ . . I $L(BF) S ZN=1 D DECODER  S BF="" Q
+"RTN","C0CMAIL2",329,0)
+ . .QUIT
+"RTN","C0CMAIL2",330,0)
  . ;
-"RTN","C0CMAIL2",328,0)
- . ; Ending Condition, close out the Segment
-"RTN","C0CMAIL2",329,0)
- . I X=END D  QUIT
-"RTN","C0CMAIL2",330,0)
- . . S LST("SEG",SGC)=$G(LST("SEG",SGC))_"^"_(D1-1)
 "RTN","C0CMAIL2",331,0)
- . . I $L(BF) S ZN=1 D DECODER  S BF="" Q
+ . ; Accumulate the lengths of other lines of the message
 "RTN","C0CMAIL2",332,0)
- . .QUIT
+ . S BCN=BCN+$L(X)
 "RTN","C0CMAIL2",333,0)
- . ;
+ . ; Split out the Content Info
 "RTN","C0CMAIL2",334,0)
- . ; Accumulate the lengths of other lines of the message
+ . I X[CON D  Q
 "RTN","C0CMAIL2",335,0)
- . S BCN=BCN+$L(X)
+ . . S J=$P(X,CON,2)
 "RTN","C0CMAIL2",336,0)
- . ; Split out the Content Info
+ . . I J[" boundary=" D
 "RTN","C0CMAIL2",337,0)
- . I X[CON D  Q
+ . . . S SEP=$P($P(J," boundary=",2),"""",2),END=SEP_FLG
 "RTN","C0CMAIL2",338,0)
- . . S J=$P(X,CON,2)
+ . . . Q:SEP?2"-"5.ANP
 "RTN","C0CMAIL2",339,0)
- . . I J[" boundary=" D
+ . . . ;
 "RTN","C0CMAIL2",340,0)
- . . . S SEP=$P($P(J," boundary=",2),"""",2),END=SEP_FLG
+ . . . D ERROR("ER11")
 "RTN","C0CMAIL2",341,0)
- . . . Q:SEP?2"-"5.ANP
+ . . . Q:SEP'[" "
 "RTN","C0CMAIL2",342,0)
  . . . ;
 "RTN","C0CMAIL2",343,0)
- . . . D ERROR("ER11")
+ . . . D ERROR("ER12")
 "RTN","C0CMAIL2",344,0)
- . . . Q:SEP'[" "
+ . . .QUIT
 "RTN","C0CMAIL2",345,0)
+ . . S LST("SEG",SGC,"CONTENT",$P(J,":"))=$P(J,":",2,9)
+"RTN","C0CMAIL2",346,0)
+ . .QUIT
+"RTN","C0CMAIL2",347,0)
+ . ;
+"RTN","C0CMAIL2",348,0)
+ . ; Everything else is Text, Check for CCR/CCD.
+"RTN","C0CMAIL2",349,0)
+ . N KK,UBF
+"RTN","C0CMAIL2",350,0)
+ . D
+"RTN","C0CMAIL2",351,0)
+ . . S UBF=$$UPPER(X)
+"RTN","C0CMAIL2",352,0)
+ . . I UBF["<CONTINUITYOFCARERECORD"   S $P(LST("SEG",SGC),U,3)="CCR" Q
+"RTN","C0CMAIL2",353,0)
+ . . ;
+"RTN","C0CMAIL2",354,0)
+ . . I UBF["<CLINICALDOCUMENT"         S $P(LST("SEG",SGC),U,3)="CCD" Q
+"RTN","C0CMAIL2",355,0)
+ . .QUIT
+"RTN","C0CMAIL2",356,0)
+ . ; Look for directives in the text before it gets published
+"RTN","C0CMAIL2",357,0)
+ . ;  Look for "=3D" and replace it with a single "=".  I can do more parsing
+"RTN","C0CMAIL2",358,0)
+ . ;  but there may be situations where the line has been wrapped.
+"RTN","C0CMAIL2",359,0)
+ . D:X["=3D"
+"RTN","C0CMAIL2",360,0)
+ . . F KK=1:1 S X=$P(X,"=3D",1)_"="_$P(X,"=3D",2,999) Q:X'["=3D"
+"RTN","C0CMAIL2",361,0)
+ . .QUIT
+"RTN","C0CMAIL2",362,0)
+ . S LST("SEG",SGC,"TXT",D1)=X
+"RTN","C0CMAIL2",363,0)
+ .QUIT
+"RTN","C0CMAIL2",364,0)
+ QUIT
+"RTN","C0CMAIL2",365,0)
+ ;  ===================
+"RTN","C0CMAIL2",366,0)
+ ; Break down the Buffer Array so it can be saved.
+"RTN","C0CMAIL2",367,0)
+ ;  BF is passed in.
+"RTN","C0CMAIL2",368,0)
+DECODER ; 
+"RTN","C0CMAIL2",369,0)
+ N RCNT,TBF,UBF,ZBF,ZI,ZJ,ZK,ZSIZE
+"RTN","C0CMAIL2",370,0)
+ S ZBF=BF
+"RTN","C0CMAIL2",371,0)
+ ;  Full Buffer, BF, now check for Encryption and Unpack
+"RTN","C0CMAIL2",372,0)
+ F RCNT=1:1:$L(ZBF,"=")   D
+"RTN","C0CMAIL2",373,0)
+ . N BF
+"RTN","C0CMAIL2",374,0)
+ . S BF=$P(ZBF,"=",RCNT)
+"RTN","C0CMAIL2",375,0)
+ . ;  Unpacking the 64 bit encoding
+"RTN","C0CMAIL2",376,0)
+ . S TBF=$TR($$DECODE^RGUTUU(BF),$C(10,12,13))
+"RTN","C0CMAIL2",377,0)
+ . D:$L(TBF)
+"RTN","C0CMAIL2",378,0)
+ . . N C,OK,OKCNT,KK,XBF,UBF
+"RTN","C0CMAIL2",379,0)
+ . . D
+"RTN","C0CMAIL2",380,0)
+ . . . S UBF=$$UPPER(TBF)
+"RTN","C0CMAIL2",381,0)
+ . . . I UBF["<CONTINUITYOFCARERECORD XMLNS=" S $P(LST("SEG",SGC),U,3)="CCR" Q
+"RTN","C0CMAIL2",382,0)
  . . . ;
-"RTN","C0CMAIL2",346,0)
- . . . D ERROR("ER12")
-"RTN","C0CMAIL2",347,0)
+"RTN","C0CMAIL2",383,0)
+ . . . I UBF["<CLINICALDOCUMENT XMLNS="       S $P(LST("SEG",SGC),U,3)="CCD" Q
+"RTN","C0CMAIL2",384,0)
  . . .QUIT
-"RTN","C0CMAIL2",348,0)
- . . S LST("SEG",SGC,"CONTENT",$P(J,":"))=$P(J,":",2,9)
-"RTN","C0CMAIL2",349,0)
+"RTN","C0CMAIL2",385,0)
+ . . ; Check for Bad Signature Decoding, after 100 bad characters
+"RTN","C0CMAIL2",386,0)
+ . . S OK=1,OKCNT=0
+"RTN","C0CMAIL2",387,0)
+ . . F KK=1:1:$L(UBF) S C=$A(UBF,KK) S:C>126 OKCNT=OKCNT+1 I OKCNT>100 S OK=0 Q
+"RTN","C0CMAIL2",388,0)
+ . . ;
+"RTN","C0CMAIL2",389,0)
+ . . D
+"RTN","C0CMAIL2",390,0)
+ . . . I 'OK S (BF,UBF,TBF,XBF)="<Crypto-Signature redacted>" Q
+"RTN","C0CMAIL2",391,0)
+ . . . ;
+"RTN","C0CMAIL2",392,0)
+ . . . S BF=BF_"="
+"RTN","C0CMAIL2",393,0)
+ . . . D NORMAL(.XBF,.TBF)
+"RTN","C0CMAIL2",394,0)
+ . . .QUIT
+"RTN","C0CMAIL2",395,0)
+ . . M LST("SEG",SGC,"XML",RCNT)=XBF
+"RTN","C0CMAIL2",396,0)
  . .QUIT
-"RTN","C0CMAIL2",350,0)
+"RTN","C0CMAIL2",397,0)
+ .QUIT
+"RTN","C0CMAIL2",398,0)
+ QUIT
+"RTN","C0CMAIL2",399,0)
+ ;  ===================
+"RTN","C0CMAIL2",400,0)
+ ;  OUTXML = OUTBF  = OUT   = OUTPUT ARRAY TO BE BUILT
+"RTN","C0CMAIL2",401,0)
+ ;  BF     = INXML = INPUT ARRAY TO PROVIDE INPUT
+"RTN","C0CMAIL2",402,0)
+ ;   >D NORMAL^C0CMAIL(.OUT,BF)
+"RTN","C0CMAIL2",403,0)
+NORMAL(OUTXML,INXML)    ;NORMALIZES AN XML STRING PASSED BY NAME IN INXML
+"RTN","C0CMAIL2",404,0)
+ ; INTO AN XML ARRAY RETURNED IN OUTXML, ALSO PASSED BY NAME
+"RTN","C0CMAIL2",405,0)
+ ;
+"RTN","C0CMAIL2",406,0)
+ N ZN,OUTBF,XX,ZSEP
+"RTN","C0CMAIL2",407,0)
+ S INXML=$TR(INXML,$C(10,12,13))
+"RTN","C0CMAIL2",408,0)
+ S ZN=1,ZSEP=">"
+"RTN","C0CMAIL2",409,0)
+ S OUTBF(1)=$P(INXML,"><",1)_ZSEP,XX="<"_$P(INXML,"><",2)_ZSEP,ZN=2,ZL=1
+"RTN","C0CMAIL2",410,0)
+ F ZN=ZN+1:1:$L(INXML,"><")  D   Q:XX=""
+"RTN","C0CMAIL2",411,0)
+ . S XX=$P(INXML,"><",ZN)
+"RTN","C0CMAIL2",412,0)
+ . S:$E($RE(XX))=">" ZSEP=""
+"RTN","C0CMAIL2",413,0)
+ . Q:XX=""
+"RTN","C0CMAIL2",414,0)
  . ;
-"RTN","C0CMAIL2",351,0)
- . ; Everything else is Text, Check for CCR/CCD.
-"RTN","C0CMAIL2",352,0)
- . N KK,UBF
-"RTN","C0CMAIL2",353,0)
+"RTN","C0CMAIL2",415,0)
+ . S XX="<"_XX_ZSEP
+"RTN","C0CMAIL2",416,0)
  . D
-"RTN","C0CMAIL2",354,0)
- . . S UBF=$$UPPER(X)
-"RTN","C0CMAIL2",355,0)
- . . I UBF["<CONTINUITYOFCARERECORD"   S $P(LST("SEG",SGC),U,3)="CCR" Q
-"RTN","C0CMAIL2",356,0)
+"RTN","C0CMAIL2",417,0)
+ . . I $L(XX)<4000 S OUTBF(ZL)=XX,XX=$P(INXML,"><",ZN),ZL=ZL+1   Q
+"RTN","C0CMAIL2",418,0)
  . . ;
-"RTN","C0CMAIL2",357,0)
- . . I UBF["<CLINICALDOCUMENT"         S $P(LST("SEG",SGC),U,3)="CCD" Q
-"RTN","C0CMAIL2",358,0)
+"RTN","C0CMAIL2",419,0)
+ . . D ERROR("ER05")
+"RTN","C0CMAIL2",420,0)
+ . . F ZL=ZL+1:1 D   Q:XX=""
+"RTN","C0CMAIL2",421,0)
+ . . .  N XL
+"RTN","C0CMAIL2",422,0)
+ . . .  S XL=$E(XX,1,4000)
+"RTN","C0CMAIL2",423,0)
+ . . .  S $E(XX,1,4000)=""   ; S XX=$E(XX,4001,999999) ; Remove 4K characters
+"RTN","C0CMAIL2",424,0)
+ . . .  S OUTBF(ZL)=XL
+"RTN","C0CMAIL2",425,0)
+ . . .QUIT
+"RTN","C0CMAIL2",426,0)
  . .QUIT
-"RTN","C0CMAIL2",359,0)
- . ; Look for directives in the text before it gets published
-"RTN","C0CMAIL2",360,0)
- . ;  Look for "=3D" and replace it with a single "=".  I can do more parsing
-"RTN","C0CMAIL2",361,0)
- . ;  but there may be situations where the line has been wrapped.
-"RTN","C0CMAIL2",362,0)
- . D:X["=3D"
-"RTN","C0CMAIL2",363,0)
- . . F KK=1:1 S X=$P(X,"=3D",1)_"="_$P(X,"=3D",2,999) Q:X'["=3D"
-"RTN","C0CMAIL2",364,0)
- . .QUIT
-"RTN","C0CMAIL2",365,0)
- . S LST("SEG",SGC,"TXT",D1)=X
-"RTN","C0CMAIL2",366,0)
+"RTN","C0CMAIL2",427,0)
  .QUIT
-"RTN","C0CMAIL2",367,0)
+"RTN","C0CMAIL2",428,0)
+ M OUTXML=OUTBF
+"RTN","C0CMAIL2",429,0)
  QUIT
-"RTN","C0CMAIL2",368,0)
+"RTN","C0CMAIL2",430,0)
  ;  ===================
-"RTN","C0CMAIL2",369,0)
- ; Break down the Buffer Array so it can be saved.
-"RTN","C0CMAIL2",370,0)
- ;  BF is passed in.
-"RTN","C0CMAIL2",371,0)
-DECODER ; 
-"RTN","C0CMAIL2",372,0)
- N RCNT,TBF,UBF,ZBF,ZI,ZJ,ZK,ZSIZE
-"RTN","C0CMAIL2",373,0)
- S ZBF=BF
-"RTN","C0CMAIL2",374,0)
- ;  Full Buffer, BF, now check for Encryption and Unpack
-"RTN","C0CMAIL2",375,0)
- F RCNT=1:1:$L(ZBF,"=")   D
-"RTN","C0CMAIL2",376,0)
- . N BF
-"RTN","C0CMAIL2",377,0)
- . S BF=$P(ZBF,"=",RCNT)
-"RTN","C0CMAIL2",378,0)
- . ;  Unpacking the 64 bit encoding
-"RTN","C0CMAIL2",379,0)
- . S TBF=$TR($$DECODE^RGUTUU(BF),$C(10,12,13))
-"RTN","C0CMAIL2",380,0)
- . D:$L(TBF)
-"RTN","C0CMAIL2",381,0)
- . . N C,OK,OKCNT,KK,XBF,UBF
-"RTN","C0CMAIL2",382,0)
- . . D
-"RTN","C0CMAIL2",383,0)
- . . . S UBF=$$UPPER(TBF)
-"RTN","C0CMAIL2",384,0)
- . . . I UBF["<CONTINUITYOFCARERECORD XMLNS=" S $P(LST("SEG",SGC),U,3)="CCR" Q
-"RTN","C0CMAIL2",385,0)
- . . . ;
-"RTN","C0CMAIL2",386,0)
- . . . I UBF["<CLINICALDOCUMENT XMLNS="       S $P(LST("SEG",SGC),U,3)="CCD" Q
-"RTN","C0CMAIL2",387,0)
- . . .QUIT
-"RTN","C0CMAIL2",388,0)
- . . ; Check for Bad Signature Decoding, after 100 bad characters
-"RTN","C0CMAIL2",389,0)
- . . S OK=1,OKCNT=0
-"RTN","C0CMAIL2",390,0)
- . . F KK=1:1:$L(UBF) S C=$A(UBF,KK) S:C>126 OKCNT=OKCNT+1 I OKCNT>100 S OK=0 Q
-"RTN","C0CMAIL2",391,0)
- . . ;
-"RTN","C0CMAIL2",392,0)
- . . D
-"RTN","C0CMAIL2",393,0)
- . . . I 'OK S (BF,UBF,TBF,XBF)="<Crypto-Signature redacted>" Q
-"RTN","C0CMAIL2",394,0)
- . . . ;
-"RTN","C0CMAIL2",395,0)
- . . . S BF=BF_"="
-"RTN","C0CMAIL2",396,0)
- . . . D NORMAL(.XBF,.TBF)
-"RTN","C0CMAIL2",397,0)
- . . .QUIT
-"RTN","C0CMAIL2",398,0)
- . . M LST("SEG",SGC,"XML",RCNT)=XBF
-"RTN","C0CMAIL2",399,0)
- . .QUIT
-"RTN","C0CMAIL2",400,0)
- .QUIT
-"RTN","C0CMAIL2",401,0)
- QUIT
-"RTN","C0CMAIL2",402,0)
- ;  ===================
-"RTN","C0CMAIL2",403,0)
- ;  OUTXML = OUTBF  = OUT   = OUTPUT ARRAY TO BE BUILT
-"RTN","C0CMAIL2",404,0)
- ;  BF     = INXML = INPUT ARRAY TO PROVIDE INPUT
-"RTN","C0CMAIL2",405,0)
- ;   >D NORMAL^C0CMAIL(.OUT,BF)
-"RTN","C0CMAIL2",406,0)
-NORMAL(OUTXML,INXML)    ;NORMALIZES AN XML STRING PASSED BY NAME IN INXML
-"RTN","C0CMAIL2",407,0)
- ; INTO AN XML ARRAY RETURNED IN OUTXML, ALSO PASSED BY NAME
-"RTN","C0CMAIL2",408,0)
- ;
-"RTN","C0CMAIL2",409,0)
- N ZN,OUTBF,XX,ZSEP
-"RTN","C0CMAIL2",410,0)
- S INXML=$TR(INXML,$C(10,12,13))
-"RTN","C0CMAIL2",411,0)
- S ZN=1,ZSEP=">"
-"RTN","C0CMAIL2",412,0)
- S OUTBF(1)=$P(INXML,"><",1)_ZSEP,XX="<"_$P(INXML,"><",2)_ZSEP,ZN=2,ZL=1
-"RTN","C0CMAIL2",413,0)
- F ZN=ZN+1:1:$L(INXML,"><")  D   Q:XX=""
-"RTN","C0CMAIL2",414,0)
- . S XX=$P(INXML,"><",ZN)
-"RTN","C0CMAIL2",415,0)
- . S:$E($RE(XX))=">" ZSEP=""
-"RTN","C0CMAIL2",416,0)
- . Q:XX=""
-"RTN","C0CMAIL2",417,0)
- . ;
-"RTN","C0CMAIL2",418,0)
- . S XX="<"_XX_ZSEP
-"RTN","C0CMAIL2",419,0)
- . D
-"RTN","C0CMAIL2",420,0)
- . . I $L(XX)<4000 S OUTBF(ZL)=XX,XX=$P(INXML,"><",ZN),ZL=ZL+1   Q
-"RTN","C0CMAIL2",421,0)
- . . ;
-"RTN","C0CMAIL2",422,0)
- . . D ERROR("ER05")
-"RTN","C0CMAIL2",423,0)
- . . F ZL=ZL+1:1 D   Q:XX=""
-"RTN","C0CMAIL2",424,0)
- . . .  N XL
-"RTN","C0CMAIL2",425,0)
- . . .  S XL=$E(XX,1,4000)
-"RTN","C0CMAIL2",426,0)
- . . .  S $E(XX,1,4000)=""   ; S XX=$E(XX,4001,999999) ; Remove 4K characters
-"RTN","C0CMAIL2",427,0)
- . . .  S OUTBF(ZL)=XL
-"RTN","C0CMAIL2",428,0)
- . . .QUIT
-"RTN","C0CMAIL2",429,0)
- . .QUIT
-"RTN","C0CMAIL2",430,0)
- .QUIT
 "RTN","C0CMAIL2",431,0)
- M OUTXML=OUTBF
+UPPER(X) ; Convert any lowercase letters to Uppercase letters
 "RTN","C0CMAIL2",432,0)
- QUIT
+ QUIT $TR(X,"abcdefghijklmnopqrstuvwxyz","ABCDEFGHIJKLMNOPQRSTUVWXYZ")
 "RTN","C0CMAIL2",433,0)
  ;  ===================
 "RTN","C0CMAIL2",434,0)
-UPPER(X) ; Convert any lowercase letters to Uppercase letters
+ ; EN is a counter that remains between error events
 "RTN","C0CMAIL2",435,0)
- QUIT $TR(X,"abcdefghijklmnopqrstuvwxyz","ABCDEFGHIJKLMNOPQRSTUVWXYZ")
+ERROR(ER) ; Error Handler
 "RTN","C0CMAIL2",436,0)
+ N TXXQ,XXXQ
+"RTN","C0CMAIL2",437,0)
+ S XXXQ="Unknown Error Encountered = "_ER
+"RTN","C0CMAIL2",438,0)
+ S TXXQ=$P($T(@(ER_"^"_$T(+0))),";;",2,99)
+"RTN","C0CMAIL2",439,0)
+ I TXXQ'=""  D
+"RTN","C0CMAIL2",440,0)
+ . I TXXQ["_" X "S TXXQ="_TXXQ
+"RTN","C0CMAIL2",441,0)
+ . S XXXQ=TXXQ
+"RTN","C0CMAIL2",442,0)
+ .QUIT
+"RTN","C0CMAIL2",443,0)
+ S EN(ER)=$G(EN(ER))+1
+"RTN","C0CMAIL2",444,0)
+ S LST("ERR",ER,EN(ER))=XXXQ
+"RTN","C0CMAIL2",445,0)
+ QUIT
+"RTN","C0CMAIL2",446,0)
  ;  ===================
-"RTN","C0CMAIL2",437,0)
- ; EN is a counter that remains between error events
-"RTN","C0CMAIL2",438,0)
-ERROR(ER) ; Error Handler
-"RTN","C0CMAIL2",439,0)
- N TXXQ,XXXQ
-"RTN","C0CMAIL2",440,0)
- S XXXQ="Unknown Error Encountered = "_ER
-"RTN","C0CMAIL2",441,0)
- S TXXQ=$P($T(@(ER_"^"_$T(+0))),";;",2,99)
-"RTN","C0CMAIL2",442,0)
- I TXXQ'=""  D
-"RTN","C0CMAIL2",443,0)
- . I TXXQ["_" X "S TXXQ="_TXXQ
-"RTN","C0CMAIL2",444,0)
- . S XXXQ=TXXQ
-"RTN","C0CMAIL2",445,0)
- .QUIT
-"RTN","C0CMAIL2",446,0)
- S EN(ER)=$G(EN(ER))+1
 "RTN","C0CMAIL2",447,0)
- S LST("ERR",ER,EN(ER))=XXXQ
+ER01 ;;Message Missing
 "RTN","C0CMAIL2",448,0)
+ER02 ;;Message Text Missing
+"RTN","C0CMAIL2",449,0)
+ER03 ;;Message Not Identifiable
+"RTN","C0CMAIL2",450,0)
+ER04 ;;Segment is too large
+"RTN","C0CMAIL2",451,0)
+ER05 ;;Mailbox Missing
+"RTN","C0CMAIL2",452,0)
+ER06 ;;"User Missing = "_$G(DUZ)
+"RTN","C0CMAIL2",453,0)
+ER07 ;;"Bad DUZ = "_DUZ
+"RTN","C0CMAIL2",454,0)
+ER08 ;;"Bad Basket ID = "_MBLST_" >> "_$G(TN)
+"RTN","C0CMAIL2",455,0)
+ER10 ;;"Bad Separator found = "_X
+"RTN","C0CMAIL2",456,0)
+ER11 ;;"Non-Standard Separator Found:>"_$G(J)
+"RTN","C0CMAIL2",457,0)
+ER12 ;;"Spaces are not allowed in Separators:>"_$G(J)
+"RTN","C0CMAIL2",458,0)
+ ;  vvvvvvvvvvvvvvv  Not Needed  vvvvvvvvvvvvvvvvvvvvvvvvvv
+"RTN","C0CMAIL2",459,0)
+ ;  End note if needed
+"RTN","C0CMAIL2",460,0)
  QUIT
-"RTN","C0CMAIL2",449,0)
- ;  ===================
-"RTN","C0CMAIL2",450,0)
-ER01 ;;Message Missing
-"RTN","C0CMAIL2",451,0)
-ER02 ;;Message Text Missing
-"RTN","C0CMAIL2",452,0)
-ER03 ;;Message Not Identifiable
-"RTN","C0CMAIL2",453,0)
-ER04 ;;Segment is too large
-"RTN","C0CMAIL2",454,0)
-ER05 ;;Mailbox Missing
-"RTN","C0CMAIL2",455,0)
-ER06 ;;"User Missing = "_$G(DUZ)
-"RTN","C0CMAIL2",456,0)
-ER07 ;;"Bad DUZ = "_DUZ
-"RTN","C0CMAIL2",457,0)
-ER08 ;;"Bad Basket ID = "_MBLST_" >> "_$G(TN)
-"RTN","C0CMAIL2",458,0)
-ER10 ;;"Bad Separator found = "_X
-"RTN","C0CMAIL2",459,0)
-ER11 ;;"Non-Standard Separator Found:>"_$G(J)
-"RTN","C0CMAIL2",460,0)
-ER12 ;;"Spaces are not allowed in Separators:>"_$G(J)
 "RTN","C0CMAIL2",461,0)
- ;  vvvvvvvvvvvvvvv  Not Needed  vvvvvvvvvvvvvvvvvvvvvvvvvv
-"RTN","C0CMAIL2",462,0)
- ;  End note if needed
-"RTN","C0CMAIL2",463,0)
- QUIT
-"RTN","C0CMAIL2",464,0)
  ;  ===================
 "RTN","C0CMAIL3")
-0^83^B224733815
+0^83^B222669398
 "RTN","C0CMAIL3",1,0)
 C0CMAIL3 ; Communications for MIME Documents and MultiMIME ; 3110420 ; rcr/rcr   ; 5/10/12 2:51pm
 "RTN","C0CMAIL3",2,0)
- ;;1.2;C0C;;May 11, 2012;Build 50
+ ;;1.2;CCD/CCR GENERATION UTILITIES;;Oct 30, 2012;Build 51
 "RTN","C0CMAIL3",3,0)
  ;Copyright 2011 Chris Richardson, Richardson Computer Research
